#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum LogUnionOperation {
    /// Keeps all points if multiple series contain points with a duplicate timestamp.
    #[serde(rename = "KEEP_ALL")]
    KeepAll,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl LogUnionOperation {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            LogUnionOperation::KeepAll => "KEEP_ALL",
            LogUnionOperation::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for LogUnionOperation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for LogUnionOperation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for LogUnionOperation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<LogUnionOperation, conjure_object::plain::ParseEnumError> {
        match v {
            "KEEP_ALL" => Ok(LogUnionOperation::KeepAll),
            v => v.parse().map(|v| LogUnionOperation::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for LogUnionOperation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<LogUnionOperation, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the LogUnionOperation enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
